---
image: ghcr.io/oca/oca-ci/py3.6-ocb12.0:latest
stages:
  - lint
  - test
  - deploy

before_script:
  - >
    function section_start {
      GITLABCI_SECTION_DATE=$(date '+%s')
      GITLABCI_SECTION_NAME="$1"
      GITLABCI_SECTION_TEXT="$2"
      COLOR_START="\033[1;35m"
      COLOR_END="\033[0m"
      stdbuf -i0 -o0 -e0 echo -e "section_start:${GITLABCI_SECTION_DATE}:${GITLABCI_SECTION_NAME}[collapsed=true]\r\e[0K${COLOR_START}${GITLABCI_SECTION_TEXT}${COLOR_END}"
    }

    function section_end {
        GITLABCI_SECTION_DATE=$(date '+%s')
        GITLABCI_SECTION_NAME="$1"
        stdbuf -i0 -o0 -e0 echo -e "section_end:${GITLABCI_SECTION_DATE}:${GITLABCI_SECTION_NAME}\r\e[0K"
    }
  - pip install twine

flake8:
  stage: lint
  script:
    - pip install git+https://github.com/OCA/mirrors-flake8.git@v3.4.1
    - flake8 --max-line-length=88 --exclude=__init__.py,setup/*/setup.py --ignore=E123,E133,E226,E241,E242,F811,F601,W503,W504,E203 .

test:
  stage: test
  services:
    - postgres:12
  variables:
    MAKEPOT: "1"
    POSTGRES_DB: project_ci_test
    POSTGRES_USER: odoo
    POSTGRES_PASSWORD: "odoo"
    RUNNER_HOME: '/home/gitlab-runner'
    PIP_INDEX_URL: 'https://pypi.org/simple'
  script:
    - section_start "deps" "Install addons and dependencies"
    - time oca_install_addons
    - section_end "deps"
    - section_start "check_licenses" "Check licenses"
    - time manifestoo -d . check-licenses
    - section_end "check_licenses"
    - section_start "check_dev" "Check development status"
    - time manifestoo -d . check-dev-status --default-dev-status=Beta
    - section_end "check_dev"
    - section_start "init_db" "Initialize test db"
    - time oca_init_test_database
    - section_end "init_db"
    - section_start "test" "Run tests"
    - time oca_run_tests
    - section_end "test"

deploy:
  stage: deploy
  script:
    - |
        for PKG_FOLDER in $(ls setup); do
          if [ -d setup/$PKG_FOLDER ]; then
            cd setup/$PKG_FOLDER/
            python setup.py sdist bdist_wheel
            twine upload -r pypi --username __token__ --password $PYPI_TOKEN --skip-existing --verbose dist/*
            cd ..
          fi
        done
  only:
    - main
  when: manual